<?
include "init.php";

if (empty($_GET['p'])) {
  $_GET['p'] = 1;
}

// ################# Start getting Youtube GData ##############################

$user_data           = YT_GetUserProfile($_GET['u']);
$user_playlists_entry = YT_GetUserPlaylistsEntry($_GET['lid'], $_GET['p'], $config['list_per_page']);

// ################# Start parse xml attributes manually ######################

preg_match_all('/<[^>]+>/s',$user_data[1],$tags);

foreach ($tags[0] as $k => $v) {

  $v = str_replace('"',"\'",$v);

  if (substr($v, 0, 16) == '<media:thumbnail') {
    preg_match("/url='(.*)'/i", $v, $matches);
    $thumbnail = $matches[1];
  }

  if (substr($v, 0, 14) == '<yt:statistics') {
    preg_match("/viewCount='([0-9]*)'/i", $v, $matches);
    $view_count = $matches[1];
    preg_match("/subscriberCount='([0-9]*)'/i", $v, $matches);
    $subscriber_count = $matches[1];
    preg_match("/videoWatchCount='([0-9]*)'/i", $v, $matches);
    $view_watch_count = $matches[1];
    preg_match("/lastWebAccess='(.*)'/i", $v, $matches);
    $last_web_access = $matches[1];
  }

  if (substr($v, 0, 12) == '<gd:feedLink') {
    preg_match("/favorites' countHint='(.*)'/i", $v, $matches);
    if(empty($favorites_count)) $favorites_count = $matches[1];
    preg_match("/contacts' countHint='(.*)'/i", $v, $matches);
    if(empty($contacts_count)) $contacts_count = $matches[1];
    preg_match("/subscriptions' countHint='(.*)'/i", $v, $matches);
    if(empty($subscriptions_count)) $subscriptions_count = $matches[1];
  }
}

preg_match_all('/<[^>]+>/s',$user_playlists_entry[1],$tags);

$i=0;
foreach ($tags[0] as $k => $v) {

  $v = str_replace('"',"\'",$v);

  if (substr($v, 0, 12) == '<yt:duration') {
    preg_match("/seconds='(.*)'/i", $v, $matches);
    $user_playlists_entry[0][entry][$i][duration] = $matches[1];
  }

  if (substr($v, 0, 14) == '<yt:statistics') {
    preg_match("/viewCount='(.*)'/i", $v, $matches);
    $user_playlists_entry[0][entry][$i][view_count] = $matches[1];
  }

  if (substr($v, 0, 10) == '<gd:rating') {
    preg_match("/numRaters='(.*)' average/i", $v, $matches);
    $user_playlists_entry[0][entry][$i][rating_num_raters] = $matches[1];

    preg_match("/average='(.*)'/i", $v, $matches);
    $user_playlists_entry[0][entry][$i][rating_average] = $matches[1];
  }

  if (substr($v, 0, 5) == '<link') {
    preg_match("/v=(.*)'/i", $v, $matches);//print
    if(empty($user_playlists_entry[0][entry][$i][id]) || substr($user_playlists_entry[0][entry][$i][id],0,7) == 'http://') 
      $user_playlists_entry[0][entry][$i][id] = $matches[1];
  }

  if (substr($v, 0, 7) == '</entry') {
    $i++;
  }
}

// ################# Start construct video data ###############################

if(is_array($user_playlists_entry[0][entry])) {
  foreach($user_playlists_entry[0][entry] as $k => $v) {
    $user_playlists_entry[0][entry][$k][author]       = $user_playlists_entry[0][entry][$k][author][0][name];
    $user_playlists_entry[0][entry][$k][description]  = $user_playlists_entry[0][entry][$k]['media:group'][0]['media:description'];
    $user_playlists_entry[0][entry][$k][category]     = $user_playlists_entry[0][entry][$k]['media:group'][0]['media:category'];
    $user_playlists_entry[0][entry][$k][thumbnail][0] = "http://img.youtube.com/vi/" . $user_playlists_entry[0][entry][$k][id] . "/0.jpg";
    $user_playlists_entry[0][entry][$k][thumbnail][1] = "http://img.youtube.com/vi/" . $user_playlists_entry[0][entry][$k][id] . "/1.jpg";
    $user_playlists_entry[0][entry][$k][thumbnail][2] = "http://img.youtube.com/vi/" . $user_playlists_entry[0][entry][$k][id] . "/2.jpg";
    $user_playlists_entry[0][entry][$k][thumbnail][3] = "http://img.youtube.com/vi/" . $user_playlists_entry[0][entry][$k][id] . "/3.jpg";

    $keywords_raw = explode(',',$user_playlists_entry[0][entry][$k]['media:group'][0]['media:keywords']);

    $i=0;
    foreach($keywords_raw as $k2 => $v2) {
      $user_playlists_entry[0][entry][$k][keywords][$i] = trim($v2);
      $i++;
    }
  }
}

if ($user_data[0]['yt:gender']=='m') $gender = 'Male';
elseif ($user_data[0]['yt:gender']=='f') $gender = 'Female';

// ################# Start calculate pagination ###############################

if((($_GET['p']) * $config['list_per_page']) <= $user_playlists_entry[0]['opensearch:totalresults']) {
  $next_page = $_GET['p'] + 1;
}
if($_GET['p']>1) {
  $prev_page = $_GET['p'] - 1;
}

// ################# Start assign template variables ##########################

$tpl->assign('join_date',$user_data[0][published]);
$tpl->assign('title',$user_data[0][title]);
$tpl->assign('name',$user_data[0][author][0][name]);
$tpl->assign('username',$user_data[0]['yt:username']);
$tpl->assign('books',$user_data[0]['yt:books']);
$tpl->assign('gender',$gender);
$tpl->assign('hobbies',$user_data[0]['yt:hobbies']);
$tpl->assign('location',$user_data[0]['yt:location']);
$tpl->assign('movies',$user_data[0]['yt:movies']);
$tpl->assign('music',$user_data[0]['yt:music']);
$tpl->assign('description',$user_data[0]['yt:description']);
$tpl->assign('hometown',$user_data[0]['yt:hometown']);
$tpl->assign('thumbnail',$thumbnail);
$tpl->assign('view_count',$view_count);
$tpl->assign('subscriber_count',$subscriber_count);
$tpl->assign('view_watch_count',$view_watch_count);
$tpl->assign('last_web_access',$last_web_access);
$tpl->assign('favorites_count',$favorites_count);
$tpl->assign('contacts_count',$contacts_count);
$tpl->assign('subscriptions_count',$subscriptions_count);
$tpl->assign('user_playlists_entry',$user_playlists_entry[0][entry]);
$tpl->assign('total',ceil($user_playlists_entry[0]['opensearch:totalresults'] / $config['list_per_page']));
$tpl->assign('next_page',$next_page);
$tpl->assign('prev_page',$prev_page);
$tpl->assign('curr_page',$_GET['p']);
$tpl->assign('playlist_id',$_GET['lid']);
$tpl->assign('playlist_title',$user_playlists_entry[0]['title']);
$tpl->display('user_playlists_entry.html');
?>